#include "mapedit.h"

#include <stdarg.h>
#include <stdio.h>
#include <allegro.h>
#include <dpmi.h>
//extern BITMAP *menubmp=NULL, *screenbmp=NULL, *tilebmp=NULL, *oldscreenbmp=NULL;
BITMAP *tilebmp=NULL, *tile[250], *screenbmp=NULL;
PALLETE pallete;
extern FONT *font;

int Map[1000][1000];

extern struct UserStruct {  //Map Tiles and Flags
	int tile;
   int x;
   int y;
   int screenX;
   int screenY;
} User;


void InitEditor()
{
   int TLoopX=0, TLoopY=0, TCounter=0;
   text_mode(-1);
   tilebmp=load_bitmap("maptiles.bmp",pallete);
   screenbmp=load_bitmap("maptiles.bmp",pallete);
   set_pallete(pallete);

   for(TCounter=0;TCounter<=250;TCounter++)  // Initializes the Tiles
      tile[TCounter]=load_bitmap("white.bmp",pallete);      

   LoadMapTiles();  // Loads the map tiles
   LoadFile(); // loads the map file
   DrawMap();
}

void DrawExtras() // Draws the stuff that tells the user where he is on the map
{
   int TLoopY, TLoopX;
   rect(screen,User.x*16,User.y*16,(User.x+1)*16,(User.y+1)*16,0);
   for(TLoopX=0;TLoopX<15;TLoopX++) {
      blit(tile[TLoopX],screen,0,0,TLoopX*16,180,16,16);
   }
   rect(screen,User.tile*16,180,(User.tile+1)*16,196,0);
}

void LoadMapTiles()
{
   int TCounter, TLoopY, TLoopX;

   TCounter=0;
   for(TLoopY=0;TLoopY<320;TLoopY+=16) {  //Puts the tiles into memory
      for(TLoopX=0;TLoopX<176;TLoopX+=16) {
         blit(tilebmp,tile[TCounter],TLoopX,TLoopY,0,0,16,16);
         TCounter+=1;  }
   }
}

void DrawMap()
{
   int TCounter, TLoopY, TLoopX;

   TCounter=0;
   for(TLoopY=0;TLoopY<=10;TLoopY++) { // displays the map on the screen
      for(TLoopX=0;TLoopX<20;TLoopX++) {
         blit(tile[Map[TLoopX+(User.screenX*5)][TLoopY+(User.screenY*5)]],screenbmp,0,0,TLoopX*16,TLoopY*16,16,16); }
   }
blit(screenbmp,screen,0,0,0,0,320,200);
DrawExtras();
}

void SaveFile() {
	FILE* iFile;
	if ((iFile = fopen("MAP.DAT", "wb")) == NULL) /* open file TEST.$$$ */
	{
		fprintf(stderr, "Cannot open output file.\n");
	}
   fwrite(&Map,sizeof(Map),1,iFile);     //Read the entire map into the struct
	fclose(iFile);
};

void LoadFile() {
	FILE* oFile;
	if ((oFile = fopen("MAP.DAT", "rb"))  == NULL)
	{
		fprintf(stderr, "Cannot open output file.\n");
	}
	fread(&Map,sizeof(Map),1,oFile);     //Read the entire map into the struct
	fclose(oFile);
DrawMap();
};

void ClearMap()
{
int TLoopY, TLoopX;
   for(TLoopY=0;TLoopY<=11;TLoopY++) { // sets random tile numbers into the map
      for(TLoopX=0;TLoopX<20;TLoopX++) {
//         Map[TLoopX][TLoopY]=rand() % 3; } // for random number
           Map[TLoopX][TLoopY]=0; } // to set it all to water (tile 0)
   }
DrawMap();
}


